/* $Id: disasm.h,v 1.1 1996/10/24 04:27:42 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	tAZuW[wb_
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *	Copyright (C) 1997,1998 Tachibana Eriko.
 *
 */

#ifndef	DISASM_H
#define	DISASM_H


#include "estruct.h"


#define MAX_MACRO_LEN	16
#define SXCALL_MAX	0x1000	/* SX Window use 0xa000 - 0xafff */


/* MPU_types */
#define M000	(1<<0)		/* 68000 */
#define M010	(1<<1)		/* 68010 */
#define M020	(1<<2)		/* 68020 */
#define M030	(1<<3)		/* 68030 */
#define M040	(1<<4)		/* 68040 */
#define M060	(1<<6)		/* 68060 */
#define MISP	(1<<7)		/* 060ISP(software emulation) */

typedef unsigned char mputypes;

/* FPCP_type */
#define F881	(1<<0)		/* 68881 */
#define F882	(1<<1)		/* 68882 */
#define F88x	(F881|F882)
#define F040	(1<<2)		/* 68040 */
#define F4SP	(1<<3)		/* 040FPSP(software emulation) */
#define F060	(1<<4)		/* 68060 */
#define F6SP	(1<<5)		/* 060FPSP(software emulation) */

/* MMU_type */
#define MMU851	(1<<0)		/* 68020 + 68851 */
#define MMU030	(1<<1)		/* 68030 internal MMU */
#define MMU040	(1<<2)		/* 68040 internal MMU */
#define MMU060	(1<<3)		/* 68060 internal MMU */


typedef enum {
    OTHER ,		/* ʂ̖ */
    JMPOP ,		/* 򖽗 */
    JSROP ,		/* Tu[`R[ */
    RTSOP ,		/* ^[ */
    BCCOP ,		/* 򖽗 */
    UNDEF = 15 ,	/* ` */
} opetype;


typedef enum {
    DregD ,		/* f[^WX^ */
    AregD ,		/* AhXWX^ */
    AregID ,		/* AhXWX^Ԑ */
    AregIDPI ,		/* |XgCNgAhXWX^Ԑ */
    AregIDPD ,		/* vfNgAhXWX^Ԑ */
    AregDISP ,		/* fBXv[XgtAhXWX^Ԑ */
    AregIDX ,		/* CfbNXtAhXWX^Ԑ */
    AbShort = 8 ,	/* ΃V[gAhX */
    AbLong ,		/* ΃OAhX */
    PCDISP ,		/* fBXv[XgtvOJE^ */
    PCIDX ,		/* CfbNXtvOJE^ */
    IMMED ,		/* C~fBGCgf[^ */
    SRCCR = 16 ,	/* CCR / SR ` */

    AregIDXB,		/* CfbNX&x[XfBXv[XgtAhXWX^Ԑ */
    AregPOSTIDX,	/* |XgCfbNXtԐ */
    AregPREIDX,		/* vCfbNXtԐ */
    PCIDXB,		/* CfbNX&x[XfBXv[XgtvOJE^Ԑ */
    PCPOSTIDX,		/* |XgCfbNXtPCԐ */
    PCPREIDX,		/* vCfbNXtPCԐ */

    CtrlReg,		/* 䃌WX^ */

    RegPairD,		/* WX^yA() dx:dy */
    RegPairID,		/* WX^yA(Ԑ) (rx):(ry) */
    BitField,		/* rbgtB[h {offset:width} */

    MMUreg,		/* MMUWX^ */

    FPregD,		/* FPn */
    FPCRSR,		/* FPSR,FPCR,FPIAR */
    FPPairD,		/* WX^yA() FPx:FPy */
    KFactor,		/* K-Factor {offset:width} */

} adrmode;


typedef struct {
    char	    operand[ 64 ];	/* Iyh */
    adrmode	    ea;			/* AhX[h */
    address	    opval;		/* Iyh̒l */
    address	    opval2;		/* Iyh̒l(odp) */
    address	    eaadrs;		/* Iyh̑݃AhX */
    address	    eaadrs2;		/* Iyh̑݃AhX(odp) */
    unsigned char   labelchange1;	/* x\ -1Ȃ()Ȃ(bsrp) */
    unsigned char   labelchange2;	/* x\ */
    unsigned char   exbd;		/* bd ̃TCY(0,2,4)  0ȂTvX */
    unsigned char   exod;		/* od ̃TCY(0,2,4)  0ȂTvX */
} operand;


typedef struct {
    char    opecode[ 32 ];  /*  */
    opesize size;	    /* TCY ( lea , pea  long ) ( 0 = .b .w .l .s nothing ) */
    opesize size2;	    /* TCY ( lea, pea, moveq, bset, ...  UNKNOWN ) */
    opesize default_size;   /* ̖߂̃ftHg̃TCY */
    int     bytes;	    /* ߂̃oCg */
    opetype flag;	    /* ߂̎ ( 0 = other jmp jsr rts bcc undef ) */
    mputypes mputypes;	    /* ̖߂s\MPU̎(M000|M010|...) */
    char    fpuid;	    /* _߂̃RvZbTID(0-7,-1Ȃʏ햽) */
    char    opflags;	    /* FLAGS_xxx */
    char    reserved;	    /* \ */
    address jmp;	    /* WvAhX ( 򖽗߂Ȃ ) */
    adrmode jmpea;	    /* AhX[h ( 򖽗߂Ȃ ) */
    operand op1;
    operand op2;
    operand op3;
    operand op4;
} disasm;

#define FLAG_CANNOT_UPPER	0x01
#define FLAG_NEED_COMMENT	0x02
#define FLAG_NEED_NULSTR	0x04

#ifndef OSKDIS
extern char**	OSlabel;
extern char**	FElabel;
extern char**	SXlabel;
extern char	OSCallName[MAX_MACRO_LEN];
extern char	FECallName[MAX_MACRO_LEN];
extern char	SXCallName[MAX_MACRO_LEN];
#endif
extern char	FPUID_table[16];
extern boolean	Disasm_Exact;
extern boolean	Disasm_String;
extern boolean	Disasm_UnusedTrapUndefined;
extern boolean	Disasm_AddressErrorUndefined;
extern boolean	Disasm_Dbra;
extern boolean	Disasm_MnemonicAbbreviation;
extern boolean	Disasm_SX_Window;
extern boolean	Disasm_CPU32;
extern boolean	Disasm_ColdFire;
extern mputypes	MPU_types;
extern short	MMU_type;
extern short	FPCP_type;
extern int	UndefRegLevel;
extern address	PCEND;

extern int	dis (address, disasm*, address*);


#endif	/* DISASM_H */

/* EOF */
